﻿@{
    Layout = "~/Views/Shared/_Layout.cshtml";

    ViewBag.Title = "Register";

    RegistrationStep step = Request.QueryString["Step"] != null ? Jumbula.Common.Helper.EnumHelper.ParseEnum<RegistrationStep>
    (Request.QueryString["Step"].ToString()) : RegistrationStep.Step1;
    var ists = Request.QueryString["ists"] != null ? Request.QueryString["ists"] : string.Empty;

    RegistrationStep lastStep = ViewBag.LastStep;

    var seasonDomain = ViewBag.SeasonDomain;
    var seasonTitle = ViewBag.SeasonTitle;
    bool hasWaiver = ViewBag.HasWaiver;
    bool hasPaymentPlant = ViewBag.HasPaymentPlan;
    bool hasFollowUpForm = ViewBag.HasFollowUpForms;
    var programs = ViewBag.Programs as List<MultipleRegisterProgramItemModel>;

    var continueButtonLabel = "Continue";

    var filter = ViewBag.Filter as MultipleRegisterFilterViewModel;

    var waiverCountStep = 5;
    var paymentPlanCountStep = 5;

    var checoutCountStep = 5;
    var tankyouCountStep = 6;

    var stepList = new List<bool>();

    stepList.Add(hasWaiver);
    stepList.Add(hasPaymentPlant);
    stepList.Add(hasFollowUpForm);


    foreach (var item in stepList)
    {
        if (item)
        {
            checoutCountStep++;
            tankyouCountStep++;
        }

    }

    if (hasFollowUpForm)
    {
        waiverCountStep = 6;
        if (hasWaiver)
        {
            paymentPlanCountStep = 7;
        }
        else
        {
            paymentPlanCountStep = 6;
        }

    }
    else if (hasWaiver)
    {
        paymentPlanCountStep = 6;
    }

}

<style>
    li.inactive {
        pointer-events: none;
    }
</style>

<div id="registration">
    <aside id="stepsContainer" class="hidden-md hidden-sm hidden-xs" style="min-height: 585px;">

        <div>
            <h3>
                You are<br />
                registering for<br />
                @seasonTitle
            </h3>

            <p>You can click on a circle to go back.</p>
            <ul id="steps">
                <li class="done">
                    <span class="icon jbi-check"></span>
                    <span class="title">Login</span>
                    <div class="clearfix"></div>
                </li>

                @{
                    //done, inprogress, inactive
                    var status1 = string.Empty;
                    if (step == RegistrationStep.Step1)
                    {
                        status1 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step1)
                    {
                        status1 = "done";
                    }
                    else
                    {
                        status1 = "inactive";
                    }
                }

                <li class="@status1">
                    <a href="/@seasonDomain/Register?ists=@ists&step=@RegistrationStep.Step1">
                        <span class="icon step-number">2</span>
                        <span class="title">Season programs</span>
                    </a>
                    <div class="clearfix"></div>
                </li>

                @{
                    var status2 = string.Empty;
                    if (step == RegistrationStep.Step2)
                    {
                        status2 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step2)
                    {
                        status2 = "done";
                    }
                    else
                    {
                        status2 = "inactive";
                    }
                }

                <li class="@status2">
                    <a class="side-link" href="@string.Format("/{0}/Register?ists={1}&step={2}", seasonDomain, ists, RegistrationStep.Step2)">
                        <span class="icon step-number">3</span>
                        <span class="title">Select participant</span>
                    </a>
                    <div class="clearfix"></div>
                </li>

                @{
                    var status3 = string.Empty;
                    if (step == RegistrationStep.Step3)
                    {
                        status3 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step3)
                    {
                        status3 = "done";
                    }
                    else
                    {
                        status3 = "inactive";
                    }
                }

                <li class="@status3">
                    <a class="side-link" href="/@seasonDomain/Register?ists=@ists&step=@RegistrationStep.Step3">
                        <span class="icon step-number">4</span>
                        <span class="title">Registration form</span>
                    </a>
                    <div class="clearfix"></div>
                </li>
                @if (hasFollowUpForm)
                {
                    var status4 = string.Empty;
                    if (step == RegistrationStep.Step4)
                    {
                        status4 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step4)
                    {
                        status4 = "done";
                    }
                    else
                    {
                        status4 = "inactive";
                    }

                    <li class="@status4">
                        <a class="side-link" href="/@seasonDomain/Register?ists=@ists&step=@RegistrationStep.Step4">
                            <span class="icon step-number">5</span>
                            <span class="title">Follow-up forms</span>
                        </a>
                        <div class="clearfix"></div>
                    </li>
                }
                @if (hasWaiver)
                {
                    var status5 = string.Empty;
                    if (step == RegistrationStep.Step5)
                    {
                        status5 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step5)
                    {
                        status5 = "done";
                    }
                    else
                    {
                        status5 = "inactive";
                    }

                    <li class="@status5">
                        <a class="side-link" href="/@seasonDomain/Register?ists=@ists&step=@RegistrationStep.Step5">
                            <span class="icon step-number">@waiverCountStep</span>
                            <span class="title">Waiver forms</span>
                        </a>
                        <div class="clearfix"></div>
                    </li>
                }

                @if (hasPaymentPlant)
                {
                    var status6 = string.Empty;
                    if (step == RegistrationStep.Step6)
                    {
                        status6 = "in-progress";
                    }
                    else if (lastStep >= RegistrationStep.Step6)
                    {
                        status6 = "done";
                    }
                    else
                    {
                        status6 = "inactive";
                    }

                    <li class="@status6">
                        <a class="side-link" href="/@seasonDomain/Register?ists=@ists&step=@RegistrationStep.Step6">
                            <span class="icon step-number">@paymentPlanCountStep</span>
                            <span class="title">Payment plans</span>
                        </a>
                        <div class="clearfix"></div>
                    </li>
                }
                <li>
                    <span class="icon step-number">@checoutCountStep</span>
                    <span class="title">Checkout & pay</span>
                    <div class="clearfix"></div>
                </li>
                <li>
                    <span class="icon step-number">@tankyouCountStep</span>
                    <span class="title">Thank you</span>
                    <div class="clearfix"></div>
                </li>
            </ul>
        </div>

    </aside>

    <div id="contentContainer">


        <div class="row-fluid">

            @if (step == RegistrationStep.Step1)
            {
                @Html.Partial("_Filter", filter)
            }

            <form method="post" id="multipleRegisterForm" class="clearfix">
                <div id="errorContainer" class="error-message-box">
                    <div class="margin-left20">
                        @Html.ValidationSummary()
                    </div>
                </div>

                @RenderBody()

                <section id="continueContainer">
                    <div class="col-xs-12 col-sm-12 col-md-8 col-lg-8">

                        @{
                            var preventSubmitClass = string.Empty;

                            if (step == RegistrationStep.Step2)
                            {
                                preventSubmitClass = "prevent-submit";
                            }
                        }

                        @if (Model.IsPreRegisterationMode)
                        {
                            continueButtonLabel = "Continue pre-register";
                            <p id="note">
                                Preregistration does NOT reserve a place in the class. You MUST return after registration opens at (@ViewBag.GeneralOpenRegDate) to finish registering.
                            </p>
                        }
                        else if (Model.IsLotteryMode)
                        {
                            continueButtonLabel = "Continue to lottery";
                            <p id="note">
                                Lottery does NOT reserve a place in the class. You will be notified after @ViewBag.LotteryEndDate.ToString(Jumbula.Common.Constants.Constants.DefaultDateTimeFormatWithAMPM) if you happen to win the lottery.
                            </p>
                        }
                        else
                        {
                            <p id="note">
                                Your registration is not yet confirmed. Your space in the program is not secured until you successfully submit payment and you receive an email confirmation.
                            </p>
                        }

                    </div>

                    <div class="col-xs-12 col-sm-12 col-md-4 col-lg-4 no-padding">
                        <button type="submit" id="continue" class="btn btn-jb @preventSubmitClass">@continueButtonLabel</button>
                    </div>
                </section>
            </form>
        </div>
    </div>
</div>


@section Styles{

    @Styles.Render("~/bundles/registerPageStyles")

    <link href="~/Content/Student/Register/MultipleRegister.css" rel="stylesheet" />
    <link href="~/Content/Frameworks/toastr.css" rel="stylesheet" />
    <link href="~/Content/Student/Register/ClassPagePopup.css" rel="stylesheet" />

    <style>
        .jb-radio-btn,
        .jb-checkbox {
            cursor: pointer;
            font-size: 14px;
        }
    </style>
}

@section Scripts {

    <script src="~/Scripts/Libraries/toastr.js"></script>
    <script src="~/Scripts/Student/ClassPagePopup.js"></script>
    <script type="text/javascript">

        var programs = [];

        $(document).ready(function () {

            $('.prevent-submit').click(function (e) {
                e.preventDefault();

                toastr.error('Please select a profile or register someone else.');
            })

            var jsonString = '@Html.Raw(Newtonsoft.Json.JsonConvert.SerializeObject(programs).Replace("'", "").Replace("\\\"", ""))'

            programs = JSON.parse(jsonString);

            var updateMandatoryChargeObjects = function (program) {
                for (var i = 0; i < program.Charges.length; i++) {
                    if (program.Charges[i].IsMandatory) {
                        program.Charges[i].Checked = true;
                    }
                }
            }

            var isChargeChecked = function (chargeId) {
                var chargeChecked = $(".charge-items[data-charge-id='" + chargeId + "']").hasClass('jbi-checked-box');

                return chargeChecked;
            }

            var isTuitionRadioChecked = function (tuitionId) {
                var tuitionChecked = $(".tuition-items[data-tuition-id='" + tuitionId + "']").hasClass('jbi-radio-checked');

                return tuitionChecked;
            }

            var updateTuitionObject = function (tuition, program) {

                var programChecked = program.Checked;
                var hasOneTuition = program.Tuitions.length == 1

                tuition.Checked = isTuitionRadioChecked(tuition.Id);

                if (programChecked && hasOneTuition) {
                    tuition.Checked = true;
                }

                if (tuition.Checked) {
                    program.Checked = true;
                }
            }

            var hasAnyCheckedTuition = function (program) {
                for (var i = 0; i < program.Tuitions.length; i++) {
                    if (program.Tuitions[i].Checked) {
                        return true;
                    }
                }

                return false;
            }

            var updateChargeObject = function (charge, program) {

                var programChecked = program.Checked;
                var hasOneTuition = program.Tuitions.length == 1

                charge.Checked = isChargeChecked(charge.Id);

                if (charge.IsMandatory && hasAnyCheckedTuition(program)) {
                    program.Checked = true;
                    updateMandatoryChargeObjects(program);
                }
            }

            var updateProgramObject = function (program) {
                program.Checked = isProgramCheckBoxChecked(program.Id);

                for (var i = 0; i < program.Tuitions.length; i++) {
                    updateTuitionObject(program.Tuitions[i], program);
                }

                for (var i = 0; i < program.Charges.length; i++) {
                    updateChargeObject(program.Charges[i], program);
                }
            }

            var updateJsonObject = function () {
                for (var i = 0; i < programs.length; i++) {
                    updateProgramObject(programs[i]);
                }
            }

            var isProgramCheckBoxChecked = function (programId) {
                var programChecked = $(".program-items[data-program-id='" + programId + "']").hasClass('jbi-checked-box');

                return programChecked;
            }

            var hadAnyCharges = function (program) {
                return program.Charges.length > 0;
            }

            var showHideChargesContainer = function (program) {

                for (var i = 0; i < program.Tuitions.length; i++) {
                    if (program.Tuitions[i].Checked && hadAnyCharges(program)) {
                        $(".charge-container[data-tuition-id='" + program.Tuitions[i].Id + "']").css('display', 'inline');
                    }
                    else {
                        $(".charge-container[data-tuition-id='" + program.Tuitions[i].Id + "']").css('display', 'none');
                    }
                }
            }

            var checkProgramItem = function (programId) {
                $(".program-items[data-program-id='" + programId + "']").addClass('jbi-checked-box').removeClass('jbi-check-box');
            }

            var unCheckProgramItem = function (programId) {
                $(".program-items[data-program-id='" + programId + "']").addClass('jbi-check-box').removeClass('jbi-checked-box');


                $(".program-items[data-program-id='" + programId + "']").parents('tr').find('.tuition-items').addClass('jbi-radio').removeClass('jbi-radio-checked');
            }

            var checkTuitionItem = function (tuitionId) {

                $(".tuition-items[data-tuition-id='" + tuitionId + "']").addClass('jbi-radio-checked').removeClass('jbi-radio');

                $(".tuition-items[data-tuition-id='" + tuitionId + "']").parents('td').find('.tuition-items').each(function (e) {

                    var currentTuitionId = $(this).data('tuition-id');

                    if (currentTuitionId != tuitionId) {
                        unCheckTuitionItem($(this).data('tuition-id'));
                    }
                });
            }

            var unCheckTuitionItem = function (tuitionId) {
                $(".tuition-items[data-tuition-id='" + tuitionId + "']").addClass('jbi-radio').removeClass('jbi-radio-checked');
            }

            var isAnyTuitionChecked = function (program) {

                for (var i = 0; i < program.Tuitions.length; i++) {
                    if (program.Tuitions[i].Checked) {
                        return true;
                    }
                }
            }

            var updateUIObjects = function () {

                for (var i = 0; i < programs.length; i++) {
                    if (programs[i].Checked) {
                        checkProgramItem(programs[i].Id);
                    }
                    else {
                        unCheckProgramItem(programs[i].Id);
                    }

                    showHideChargesContainer(programs[i]);

                    for (var j = 0; j < programs[i].Charges.length; j++) {

                        if (programs[i].Charges[j].Checked) {
                            checkChargeItem(programs[i].Charges[j].Id);
                        }
                        else {
                            unCheckChargeItem(programs[i].Charges[j].Id);
                        }
                    }
                }
            }

            var generateChargeHidden = function (charge, tuitionId, tuitionRandomId) {
                var randomId = Math.random() * 1000000000000000000;

                var result = ' <input  name="SelectedTuitions[' + tuitionRandomId + '].Charges.index" type="hidden" value="' + randomId + '"/>';
                result += ' <input  name="SelectedTuitions[' + tuitionRandomId + '].Charges[' + randomId + '].Id" type="hidden" value="' + charge.Id + '"/>';
                result += ' <input  name="SelectedTuitions[' + tuitionRandomId + '].Charges[' + randomId + '].IsChecked" type="hidden" value="true"/>';

                return result;
            }

            var generateTuitionHidden = function (tuition, program) {
                var randomId = Math.random() * 1000000000000000000;

                var result = ' <input  name="SelectedTuitions.Index" type="hidden" value="' + randomId + '"/>';
                result += ' <input  name="SelectedTuitions[' + randomId + '].Id" type="hidden" value="' + tuition.Id + '"/>';

                for (var i = 0; i < program.Charges.length; i++) {
                    if (program.Charges[i].Checked) {
                        result += generateChargeHidden(program.Charges[i], tuition.Id, randomId);
                    }
                }

                return result;
            }

            var generateProgramHidden = function (program) {
                var result = ' <input  name="SelectedItems" type="hidden" value="' + program.Id + '"/>';

                for (var j = 0; j < program.Tuitions.length; j++) {
                    if (program.Tuitions[j].Checked) {

                        result += generateTuitionHidden(program.Tuitions[j], program);
                    }
                }

                return result;
            }

            var updateHiddens = function () {
                var hiddens = '';

                for (var i = 0; i < programs.length; i++) {
                    if (programs[i].Checked) {
                        hiddens += generateProgramHidden(programs[i]);
                    }
                }

                $('#hiddenContainer').html(hiddens);

            }

            var updateObjectsFromHiddens = function () {

            }

            var refresh = function () {

                updateJsonObject();

                updateUIObjects();

                updateHiddens();
            }

            $('.program-items').click(function (e) {
                e.preventDefault();
                e.stopPropagation();

                var programId = $(this).data('program-id');

                if ($(this).hasClass('jbi-checked-box')) {
                    unCheckProgramItem(programId);
                }
                else {
                    checkProgramItem(programId);
                }

                refresh();

            })

            $('.tuition-items').click(function (e) {
                e.preventDefault();
                e.stopPropagation();

                var tuitionId = $(this).data('tuition-id');

                if ($(this).hasClass('jbi-radio-checked')) {
                    //unCheckTuitionItem(tuitionId);
                }
                else {
                    checkTuitionItem(tuitionId);
                }

                refresh();

            });

            var unCheckChargeItem = function (chargeId) {

                $(".charge-items[data-charge-id='" + chargeId + "']").addClass('jbi-check-box').removeClass('jbi-checked-box');
            }

            var checkChargeItem = function (chargeId) {
                $(".charge-items[data-charge-id='" + chargeId + "']").addClass('jbi-checked-box').removeClass('jbi-check-box');
            }

            $('.charge-items').click(function (e) {
                e.preventDefault();
                e.stopPropagation();

                var chargeId = $(this).data('charge-id');

                if ($(this).hasClass('jbi-checked-box')) {

                    unCheckChargeItem(chargeId);
                }
                else {
                    checkChargeItem(chargeId);
                }

                refresh();

            });

            refresh();

            $('#gradeFilterButton').click(function () {

                var grade = $('#gradeFilter').val();

                var url = 'https://' + window.location.hostname + '/' + '@seasonDomain' + '/register/' + grade;

                window.location.href = url;
            })

            $('.side-link').click(function (e) {

                if ($(this).parent('li').hasClass('inactive')) {
                    e.preventDefault();
                }
            })

            $('#continue').click(function (e) {

                if ('@step' == 'Step2') {
                    e.preventDefault();

                    toastr.error('Please select which participant is registering for these classes, or select "A new participant" to add the participant information to your profile.', null, { timeOut: 20000 });
                }

            });
        })

        var popoverOptions = {
            container: 'body',
            animation: true,
            html: true
        };

    </script>
    @RenderSection("Scripts", false)
}
